<app-action-status-notification 
  *ngIf="showImportStatusNotification()" 
  [statusNotificationDetails]="importStatusNotificationDetails" 
  (dismissStatusNotification)="dismissImportStatusNotification()" 
/>
<app-action-status-notification
  *ngIf="showPretranslationStatusNotification()" 
  [statusNotificationDetails]="pretranslationStatusNotificationDetails" 
  (dismissStatusNotification)="dismissPretranslationStatusNotification()" 
/>

<div *ngIf="retryPretranslationNotificationVisible()" class="flex-row-space-between warning-status-container">
  <div class="notification-content">
    <div class="flex-row-space-between gap-2">
      <div class="flex-row gap-2">
        <mat-icon class="info-icon">info</mat-icon>
        <div>
          <p class="notification-title">{{'PRETRANSLATION.NOTIFICATIONS.PRETRANSLATION_RETRY_TITLE' | translate}}</p>
          <p>{{'PRETRANSLATION.NOTIFICATIONS.PRETRANSLATION_RETRY_BODY' | translate}}</p>
        </div>
      </div>
      <button mat-icon-button (click)="dismissPretranslationStatusNotification()"
        [matTooltip]="'COMMON.DISMISS_STATUS_NOTIFICATION' | translate"
        [attr.aria-label]="'COMMON.DISMISS_STATUS_NOTIFICATION' | translate">
        <mat-icon>close</mat-icon>
      </button>
    </div>
    <button class="float-left retry-pretranslation-btn text-m mt-3" mat-button [attr.aria-label]="'PRETRANSLATION.RETRY' | translate" (click)="retryWebsitePretranslation()">
      <mat-icon>loop</mat-icon>
      {{ 'PRETRANSLATION.RETRY' | translate }}
    </button>
  </div>
</div>

<div *ngIf="isImportInProgress() || isPretranslationInProgress()" class="flex-row-space-between progress-container">
  <div class="flex-row gap-2">
    <mat-icon>info</mat-icon>
    <p>{{ isImportInProgress()
            ? ('TRANSLATION_IMPORT.NOTIFICATIONS.IMPORT_IN_PROGRESS' | translate)
            : ('PRETRANSLATION.PRETRANSLATION_IN_PROGRESS' | translate) 
        }}
    </p>
  </div>
  <div 
    class="pretranslation-progress" 
    *ngIf="pretranslationStatusResponse?.status === allPretranslationStatuses.IN_PROGRESS && (pretranslationStatusResponse?.totalUrls ?? 0) > 0"
  >
    <mat-progress-bar mode="determinate" [value]="getPretranslationProgressPercentage()"></mat-progress-bar>
    <p>{{'PRETRANSLATION.TRANSLATING_LABEL' | translate}} {{this.pretranslationStatusResponse?.pretranslatedUrls}}/{{this.pretranslationStatusResponse?.totalUrls}} URLs</p>
  </div>
</div>

<div class="flex-row-space-between">
  <h1 *ngIf="integrationName" class="mb-3 text-xl-semi-bold">{{ integrationName }}</h1>
  <div *ngIf="integrationName" class="pretranslation-buttons">
    <button mat-flat-button color="primary"
      (click)="openPretranslationDialog()" 
      [disabled]="isImportInProgress() || isPretranslationInProgress() || retryPretranslationNotificationVisible()"
    >
      {{'PRETRANSLATION.PRETRANSLATE_WEBSITE' | translate}}
    </button>
    <button mat-flat-button color="accent"
      *ngIf="cancelPretranslationButtonVisible()"
      (click)="cancelPretranslation()"
    >
      {{'PRETRANSLATION.CANCEL_PRETRANSLATION' | translate}}
    </button>
  </div>
</div>

<div class="mb-5 table-wrapper">
  <table id="suggestionTable" mat-table multiTemplateDataRows [dataSource]="dataSource">

    <!-- Checkbox Column -->
    <ng-container matColumnDef="select">
      <th mat-header-cell *matHeaderCellDef>
        <mat-checkbox (change)="$event ? toggleAllRows() : null" [checked]="selection.hasValue() && isAllSelected()"
          [indeterminate]="selection.hasValue() && !isAllSelected()"
          [aria-label]="'WIDGET.TEXT_EDIT.ALL_TRANSLATION_SEGMENTS' | translate">
        </mat-checkbox>
      </th>
      <td mat-cell *matCellDef="let row">
        <mat-checkbox (click)="$event.stopPropagation()" (change)="$event ? selection.toggle(row) : null"
          [checked]="selection.isSelected(row)" [aria-label]="'WIDGET.TEXT_EDIT.TRANSLATION_SEGMENT' | translate">
        </mat-checkbox>
      </td>
    </ng-container>

    <!-- source Column -->
    <ng-container matColumnDef="source">
      <th mat-header-cell *matHeaderCellDef class="w-50 table-header pl-2">
        <span *ngIf="sourceLanguage" class="language-names ml-3">
          {{languageLocalizationKey + (sourceLanguage | uppercase) | translate}}
        </span>
      </th>
      <td mat-cell *matCellDef="let element" class="px-0 align-top">
        <div>
          <div #sourceTextCell class="suggestion-text">
            {{element.text | taggedText: sourceTextCell:filter.text }}
          </div>
          <div class="details text-s pt-2 pb-3" fxLayout="column" fxLayoutAlign="center start">
            <div class="text-break">
              {{element.uri}}
            </div>
            <div class="mt-1" *ngIf="element.meta.seo || element.meta.attr">
              <ng-container [ngSwitch]="element.meta.seo">
                <ng-container *ngSwitchCase="true">
                  {{ 'WIDGET.TEXT_EDIT.SEO_ATTRIBUTE' | translate }}
                  {{ element.meta.refAttr }}
                </ng-container>
                <ng-container *ngSwitchDefault>
                  {{ 'WIDGET.TEXT_EDIT.ATTRIBUTE' | translate }}
                  {{ element.meta.attr }}
                </ng-container>
              </ng-container>
            </div>
          </div>
        </div>
      </td>
    </ng-container>

    <!-- target Column -->
    <ng-container matColumnDef="target">
      <th mat-header-cell *matHeaderCellDef class="w-50 table-header pl-2" colspan="2">
        <div class="d-flex align-items-center">
          <button class="ml-2 language-filter language-names" [matMenuTriggerFor]="targetLanguageMenu"
            #state="matMenuTrigger" [attr.aria-label]="'WIDGET.TEXT_EDIT.SELECT_TARGET_LANGUAGE' | translate">
            {{languageLocalizationKey + targetLanguage | uppercase | translate}}
            <mat-icon matSuffix>{{state.menuOpen ? 'arrow_drop_up' : 'arrow_drop_down'}}</mat-icon>
          </button>
          <mat-menu #targetLanguageMenu="matMenu" [class]="'translation-language-menu'" class="target-language-menu">
            <button mat-menu-item
              *ngFor="let targetLang of targetLanguages | sortTranslations: 'LANGUAGES':null:currentLanguage | async"
              (click)="onTargetChange(targetLang)">
              {{languageLocalizationKey + targetLang | uppercase | translate}}
            </button>
          </mat-menu>
        </div>
      </th>

      <td mat-cell *matCellDef="let element" [attr.colspan]="element===activeSegment ? 2 : null">
        <div [id]="editContainerIdPrefix + element.id" [attr.data-id]="element.id" #targetTextCell
          class="suggestion-text">
        </div>

        <div class="details pt-2 pb-3" [class.details-seo]="element.meta.seo" fxLayout="row"
          [fxLayoutAlign]="element.meta.seo ? 'space-between start' : 'space-between center'">
          <ng-container *ngIf="element!=activeSegment">
            <div *ngIf="element.translations[0].origin==segmentTranslationOrigin.MachineTranslation" class="text-s">
              {{ 'WIDGET.TEXT_EDIT.MT' | translate }}
            </div>
            <div *ngIf="element.translations[0].origin==segmentTranslationOrigin.User" class="text-s">
              {{ 'WIDGET.TEXT_EDIT.EDITED' | translate }}
            </div>
          </ng-container>
          <div [class.d-none]="!activeSegment || activeSegment.id!==element.id" class="w-100" fxLayout="row"
            fxLayoutAlign="space-between start">
            <div fxLayout="row" fxLayoutAlign="start start">
              <div fxFlex fxLayoutAlign="start start" class="unused-tag-container">
                <span class="text-nowrap pt-2">{{ 'WIDGET.TEXT_EDIT.INSERT_TAGS' | translate }}</span>
                <div [id]="'unusedTags-' + element.id"></div>
              </div>
            </div>
            <div class="button-box text-m">
              <button (click)="$event.stopPropagation(); onCancel()" mat-button color="accent">
                {{ 'WIDGET.TEXT_EDIT.CANCEL' | translate }}
              </button>
              <button #saveButton [@pulse]="pulseSaveBtn" (@pulse.done)="onAnimationEnd()"
                [disabled]="tagErrors.length>0 || tagWarnings.length>0 || isSuggestionEmpty" class="save" mat-button
                (click)="$event.stopPropagation(); onSave(element)">
                <mat-icon inline=true>check</mat-icon>
                {{ 'WIDGET.TEXT_EDIT.SAVE' | translate }}
              </button>
            </div>
          </div>
        </div>

        <div *ngIf="element===activeSegment">
          <div *ngFor="let error of tagErrors" class="tag-error" aria-live="polite">
            <mat-icon inline=true>error</mat-icon>
            {{ error.localizationKey | translate }} {{ error.tagNr}}
          </div>
          <div *ngFor="let warning of tagWarnings" class="tag-error" aria-live="polite">
            <mat-icon inline=true>error</mat-icon>
            {{ warning | translate }}
          </div>
        </div>
      </td>
    </ng-container>

    <!-- status Column -->
    <ng-container matColumnDef="status">
      <td mat-cell *matCellDef="let element" class="px-0 align-top text-center"
        [ngClass]="{ 'd-none': element===activeSegment}">
        <button *ngIf="element.translations[0].status==segmentTranslationStatus.New && element!=activeSegment"
          mat-icon-button color="accent" (click)="$event.stopPropagation(); onAccept(element)" class="mt-3"
          [matTooltip]="'WIDGET.TEXT_EDIT.ACCEPT' | translate"
          [attr.aria-label]="'WIDGET.TEXT_EDIT.ACCEPT' | translate">
          <mat-icon class="not-accepted">task_alt</mat-icon>
        </button>
        <button *ngIf="element.translations[0].status==segmentTranslationStatus.Confirmed && element!=activeSegment"
          mat-icon-button color="accent" class="mt-3" [attr.aria-label]="'WIDGET.TEXT_EDIT.CONFIRMED' | translate"
          [matTooltip]="'WIDGET.TEXT_EDIT.CONFIRMED' | translate"
          [attr.aria-label]="'WIDGET.TEXT_EDIT.CONFIRMED' | translate">
          <mat-icon class="accepted">task_alt</mat-icon>
        </button>
      </td>
    </ng-container>


    <!-- filter Column -->
    <ng-container matColumnDef="filters">
      <th mat-header-cell colspan="4" *matHeaderCellDef class="table-header">

        <div class="filters text-m">
          <div *ngIf="selection.selected.length" class="selection-info d-flex align-items-center">
            <span class=" text-m-semi-bold selection-text mr-1">
              {{ selection.selected.length }}
            </span>
            <span *ngIf="selection.selected.length==1" class="text-m-semi-bold">
              {{ 'WIDGET.TEXT_EDIT.TRANSLATION_SEGMENT' | translate }}</span>
            <span *ngIf="selection.selected.length>1" class="text-m-semi-bold">
              {{ 'WIDGET.TEXT_EDIT.TRANSLATION_SEGMENTS' | translate }}</span>
            <button class="ml-3" mat-button (click)="batchAccept()">
              <mat-icon>task_alt</mat-icon>
              {{ 'WIDGET.TEXT_EDIT.MARK_AS_CONFIRMED' | translate }}
            </button>
            <button mat-button (click)="batchDelete()">
              <mat-icon>delete_outline</mat-icon>
              <span>{{ 'WIDGET.TEXT_EDIT.DELETE' | translate }}</span>
            </button>
            <button class="ml-auto" mat-button (click)="clearSelection()">
              {{ 'WIDGET.TEXT_EDIT.DESELECT_ALL' | translate }}
            </button>
          </div>

          <div *ngIf="!selection.selected.length">
            <div class="d-flex align-items-center flex-column flex-sm-row ">
              <div class="d-flex align-items-center flex-shrink-0">
                <span class="text-m segment-count">
                  {{ resultCount }} {{ 'WIDGET.TEXT_EDIT.TRANSLATION_SEGMENTS' | translate }}
                </span>
                <button mat-icon-button (click)="loadSegments()"
                  [matTooltip]="'WIDGET.TEXT_EDIT.RELOAD_TRANSLATIONS' | translate"
                  [attr.aria-label]="'WIDGET.TEXT_EDIT.RELOAD_TRANSLATIONS' | translate">
                  <mat-icon>sync</mat-icon>
                </button>
              </div>
              <div class="d-flex align-items-center w-100 justify-content-end">
                <div class="text-search-field mr-3 ml-auto">
                  <mat-form-field appearance="outline">
                    <mat-icon matPrefix>search</mat-icon>
                    <input (keyup.enter)="searchByText()" matInput maxlength="100" type="search"
                      [(ngModel)]="searchText" [placeholder]="'WIDGET.TEXT_EDIT.SEARCH_TEXT' | translate" [attr.aria-label]="'WIDGET.TEXT_EDIT.SEARCH_TEXT' | translate">
                  </mat-form-field>
                </div>
                <div class="filter-button text-m" [class.active]="state.menuOpen">
                  <button [matMenuTriggerFor]="menu" #state="matMenuTrigger" (menuOpened)="menuOpened()">
                    {{ 'WIDGET.TEXT_EDIT.APPLY_FILTER' | translate }}
                    <mat-icon matSuffix>{{state.menuOpen ? 'arrow_drop_up' : 'arrow_drop_down'}}</mat-icon>
                  </button>
                  <mat-menu #menu="matMenu">
                    <ng-container *ngFor="let filter of filterOptions; let i = index">
                      <label [id]="filter.name+'-group-label'" class="filter-label text-s-semi-bold">
                        {{ localizationKey + filter.name | translate }}
                      </label>
                      <mat-radio-group [(ngModel)]="selectedDropdownFilters[filter.name]"
                        (keydown.tab)="manageTabKeyNavigation(filter, filterOptions.length-1, $event)"
                        (keydown.shift.tab)="manageTabKeyNavigation(filter, 0, $event)"
                        [attr.aria-labelledby]="filter.name+'-group-label'" class="radio-group">
                        <mat-radio-button (click)="$event.stopPropagation()"
                          *ngFor="let option of filter.options; let i = index" [value]="option.value"
                          (change)="onFilterSelect(filter.name, option.value)">
                          {{localizationKey + option.title | translate}}
                        </mat-radio-button>
                      </mat-radio-group>
                    </ng-container>
                  </mat-menu>
                </div>
                <div class="d-flex align-items-center gap-2 ml-2">
                  <button mat-stroked-button (click)="importTranslations()" [disabled]="importStatus == allImportStatuses.IN_PROGRESS || pretranslationStatusResponse?.status === allPretranslationStatuses.IN_PROGRESS">
                    <mat-icon class="material-icons-outlined">file_upload</mat-icon>
                    <span>{{ 'TRANSLATION_IMPORT.IMPORT' | translate }}</span>
                  </button>
                  <button mat-stroked-button (click)="exportTranslations()" [disabled]="this.noTranslations || importStatus == allImportStatuses.IN_PROGRESS">
                    <mat-icon class="material-icons-outlined">file_download</mat-icon>
                    <span>{{ 'TRANSLATION_EXPORT.EXPORT' | translate }}</span>
                  </button>
                </div>
              </div>
            </div>
          </div>

          <mat-chip-listbox>
            <ng-container *ngFor="let chip of filterChip; let i = index">
              <mat-chip-option selectable="false" *ngIf="chip.active" (removed)="removeChip(i, chip)" class="mt-3"
                [attr.aria-label]="'WIDGET.TEXT_EDIT.FILTER_CHIP' | translate">
                <button matChipRemove>
                  <mat-icon>close</mat-icon>
                </button>
                <span class="mr-1 chip-text text-m">
                  {{localizationKey + 'FILTER' | translate }}
                </span>
                <span class="text-m-semi-bold">
                  {{localizationKey + chip.localizationKey | translate }}
                </span>
              </mat-chip-option>
            </ng-container>
            <ng-container *ngFor="let chip of textFilterChip; let i = index">
              <mat-chip-option selectable="false" *ngIf="chip.value" (removed)="removeChip(i)" class="mt-3">
                <button matChipRemove>
                  <mat-icon>close</mat-icon>
                </button>
                <span class="mr-1 chip-text text-m">
                  {{localizationKey + chip.localizationKey | translate }}
                </span>
                <span class="text-m-semi-bold">
                  {{chip.value}}
                </span>
              </mat-chip-option>
            </ng-container>
          </mat-chip-listbox>
        </div>
      </th>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="['filters']">
    </tr>

    <tr mat-header-row *matHeaderRowDef="columnsToDisplayHeader" class="title-header">
    </tr>

    <tr (click)="onRowClick(element)" mat-row *matRowDef="let element; columns: columnsToDisplay;"
      [class.active-row]="element===activeSegment">
    </tr>

    <!-- no data row-->
    <tr *matNoDataRow>
      <td colspan="4">
        <div class="no-results my-5">
          <div>
            <mat-icon>manage_search</mat-icon>
          </div>
          <div *ngIf="noTranslations; else noResultsText">
            <p class="text-xl-semi-bold">
              {{ 'WIDGET.TEXT_EDIT.NO_RESULTS_TO_DISPLAY' | translate }}
            </p>
            <p class="text-l text-center"
              [innerHTML]="'WIDGET.TEXT_EDIT.NO_TRANSLATION_RESULTS_DESCRIPTION' | translate:{helpUrl}">
            </p>
          </div>
          <ng-template #noResultsText>
            <p class="text-xl-semi-bold">
              {{ 'WIDGET.TEXT_EDIT.NO_RESULTS' | translate }}
            </p>
            <p class="text-l">
              {{ 'WIDGET.TEXT_EDIT.NO_RESULTS_DESCRIPTION' | translate }}
            </p>
          </ng-template>
        </div>
      </td>
    </tr>

  </table>

  <app-mat-paginator-go-to [class.d-none]="!isLoadingResults && dataSource.length==0" [length]="resultCount"
    [pageSize]="pageSize" [pageSizeOptions]="pageSizeOptions" [showFirstLastButtons]="true"
    (page)="handlePageChange($event)"></app-mat-paginator-go-to>

</div>
